$ItemFavoritesKey = "stairway";  

// DISRUPTOR GUN INFORMATION
//----------------------------------------------------------------------------
$DamageScale[larmor, $EnergyDamageType] = 0.0;
$DamageScale[lfemale, $EnergyDamageType] = 0.0;
$ItemMax[larmor, ForceFieldPack] = 1;
$ItemMax[lfemale, ForceFieldPack] = 1;

SoundData SoundGenerateForceShield
{
   wavFileName = "generator.wav";
   profile = Profile3dNear;
};

//--------------------------------------


$spawnBuyList[0] = LightArmor;
$spawnBuyList[1] = Blaster;
$spawnBuyList[2] = ForceFieldPack;
$spawnBuyList[3] = "";

$TeamItemMax[ForceFieldPack] = 100;

$Server::JoinMsgDelay = 0.5;
$Server::JoinMsgHeight = 9;
$Server::JoinMsgLength = 18;
$Server::JoinMsg[0] = "<jc><f3>Stairway To Heaven";
$Server::JoinMsg[1] = "<jc><f1>";
$Server::JoinMsg[2] = "<jc><f2>Use your Force Field Generator Pack to build a stairway";
$Server::JoinMsg[3] = "<jc><f2>to the tower switch.  The first to touch it wins!";
$Server::JoinMsg[4] = "";
$Server::JoinMsg[5] = "<jc><f1>Press your (P)ack key to deploy a Force Field.";
$Server::warmupTime = 5;

// FORCE FIELD DETAILS
//------------------------------------------------------------------------
ItemImageData ForceFieldPackImage
{
	shapeFile = "mortarammo"; 
	mountPoint = 2; 
	mountOffset = { 0, 0.0, 0.4 }; 
	mountRotation = { 0, 3.14159, 1.57 }; 
	mass = 0.0;
	firstPerson = false;
};

ItemData ForceFieldPack
{
	description = "Force Field Generator";
	shapeFile = "mortarammo"; 
	className = "Backpack";
    heading = "eBackpacks";
	imageType = ForceFieldPackImage;
	shadowDetailMask = 4;
	mass = 0.0;
	elasticity = 0.2;
	price = 500;
	hudIcon = "deployable";
	showWeaponBar = true;
	hiliteOnActive = true;
};

function ForceFieldPack::onUse(%player,%item)
{
	if (Player::getMountedItem(%player,$BackpackSlot) != %item) 
		{
			Player::mountItem(%player,%item,$BackpackSlot);
		} else 
		{
			%client = Player::getClient(%player);
			if ($TeamItemCount[GameBase::getTeam(%player) @ %item] < $TeamItemMax[%item])
				{
					%energy = GameBase::getEnergy(%player);
					if (%energy >= 25) 
					{
						$forcefieldgenerated[%client] = "false";
						playSound(SoundGenerateForceShield,GameBase::getPosition(%player));
						Player::deployItem(%player,%item);
						Player::setItemCount(%player, %item, 1);
						Player::mountItem(%player,%item,$BackpackSlot);
						if ($forcefieldgenerated[%client] == "true") 
							{
							 	%energy = %energy - 25;
								if (%energy < 0) %energy = 0;
							      GameBase::setEnergy(%player, %energy);
							}
					} else Client::sendMessage(%client,0,"Insufficient power to generate Force Field.");
				} else Client::sendMessage(%client,0,"No further Force Field generation possible.");
		}
}

function ForceFieldPack::onDeploy(%player,%item,%pos)
{
	if (ForceFieldPack::deployShape(%player,%item)) {
		Player::decItemCount(%player,%item);
	}
}

function ForceFieldPack::deployShape(%player,%item)
{
	%client = Player::getClient(%player);
	if($TeamItemCount[GameBase::getTeam(%player) @ %item] < $TeamItemMax[%item]) 
	{
	if (GameBase::getLOSInfo(%player,3)) 
		{
			%obj = getObjectType($los::object);
	    		%set = newObject("set",SimSet);
			%num = containerBoxFillSet(%set,$StaticObjectType,$los::position,$TurretBoxMaxLength,$TurretBoxMaxWidth,$TurretBoxMaxHeight,0);
			%num = CountObjects(%set,"DeployableForceField",%num);
			deleteObject(%set);

			%prot = GameBase::getRotation(%player);
			%zRot = getWord(%prot,2);
			if (Vector::dot($los::normal,"0 0 1") > 0.6) {
				%rot = "0 0 " @ %zRot;
			}
			else {
				if (Vector::dot($los::normal,"0 0 -1") > 0.6) {
					%rot = "3.14159 0 " @ %zRot;
				}
				else {
					%rot = Vector::getRotation($los::normal);
				}
			}
			%mfield = newObject("","StaticShape",InteriorForceField,true);
			addToSet("MissionCleanup", %mfield);
			GameBase::setTeam(%mfield,GameBase::getTeam(%player));
			GameBase::setPosition(%mfield,$los::position);
			GameBase::setRotation(%mfield,%rot);
			Gamebase::setMapName(%mfield,"Force Field");
			Client::sendMessage(%client,0,"Force Field Generated");
			GameBase::startFadeIn(%mfield);
			playSound(SoundPickupBackpack,$los::position);
			playSound(ForceFieldClose,$los::position);
			$TeamItemCount[GameBase::getTeam(%player) @ "ForceFieldPack"]++;			
			$forcefieldgenerated[%client] = "true";
			%mfield.isactive = false;
			return true;
		}
		else 
			Client::sendMessage(%client,0,"Generation point out of range");
	}
	else																						  
	 	Client::sendMessage(%client,0,"No further Force Field generation possible.");

	return false;
}


StaticShapeData InteriorForceField
{
	shapeFile = "forcefield_5x5";
	//debrisId = defaultDebrisSmall;
	maxDamage = 3.00;
	visibleToSensor = true;
	isTranslucent = true;
   	description = "Force Field";
};

function ForceField::Decay(%this)
{
	%damLev = GameBase::getDamageLevel(%this);
	%decayrate = ($TeamItemCount[GameBase::getTeam(%this) @ %this] + 1.0) * 0.001;

	%damLev += %decayrate;
	if (%this.EMPEffect>0)
		{
			%damLev += 0.01;
			%this.EMPEffect--;
		}

	GameBase::setDamageLevel(%this,%damLev);
	schedule("ForceField::Decay(" @ %this @ ");", 0.1,%this);
}

function InteriorForceField::onAdd(%this)
{
	schedule("ForceField::Decay(" @ %this @ ");",0.1,%this);
}

function InteriorForceField::onDestroyed(%this)
{
   ForceField::onDestroyed(%this);
   $TeamItemCount[GameBase::getTeam(%this) @ "ForceFieldPack"]--;
}

function InteriorForceField::onDamage(%this,%type,%value,%pos,%vec,%mom,%object)
{
	%damageLevel = GameBase::getDamageLevel(%this);
	%dValue = %damageLevel + %value;
	%this.lastDamageObject = %object;
	%this.lastDamageTeam = GameBase::getTeam(%object);
	if(GameBase::getTeam(%this) == GameBase::getTeam(%object)) 
		{
			%name = GameBase::getDataName(%this);
			if(%name.className == Generator || %name.className == Station) 
				{ 
					%TDS = $Server::TeamDamageScale;
					%dValue = %damageLevel + %value * %TDS;
					%disable = GameBase::getDisabledDamage(%this);
					if(!$Server::TourneyMode && %dValue > %disable - 0.05) 
						{
					            if(%damageLevel > %disable - 0.05) return;
						            else %dValue = %disable - 0.05;
						}
				}
		}
	GameBase::setDamageLevel(%this,%dValue);
}

function ForceField::onDestroyed(%this)
{
	GameBase::startfadeout(%this);
	GameBase::stopSequence(%this,0);
   	StaticShape::objectiveDestroyed(%this);
}

